using System;
using System.Runtime.InteropServices;
using System.Runtime.CompilerServices;
using System.Text;
using System.Collections;
using System.Security.Permissions;

using Cspmclientc;
using System.Globalization;
using CSPM.Client.Obj;

// Assembly marked as compliant.
[assembly: CLSCompliant(true)]
[assembly: SecurityPermission(SecurityAction.RequestMinimum, Execution = true)]

namespace CSPM.Client.Com
{
    public class CspmClientComObject : CspmClientObject
	{
        // CSPM Client COM Object
        private Iccspmclientc icspmClient;

        private const string ERR_INVALID_INTERFACE =
            "CSPMClientComObject doesn't support interface Iccspmclientc: 0x{0}";

        public CspmClientComObject() :
            base()
        {
            // Create the CSPM Client class.
            icspmClient = new Cspmclientc.ccspmclientcClass();
        }

        public override void Dispose()
		{
            Dispose(true);
            GC.SuppressFinalize(this);
        }

        private void Dispose(bool disposing)
        {
            if (disposing && icspmClient != null)
            {
                icspmClient = null;
            }
        }

        public override int RetrieveCredentials(string targetAlias,
            string bypassFlg, string cliOpt)
        {
            return this.icspmClient.retrieveCredentials(
                targetAlias, bypassFlg, cliOpt);
        }

        public override string GetMessage
        {
            get
            {
                return this.icspmClient.getMessage();
            }
        }

        public override string GetPassword
        {
            get
            {
                return this.icspmClient.getPassword();
            }
        }

        public override string GetUserId
        {
            get
            { 
                return this.icspmClient.getUserId();
            }
        }

        public override string GetXmlData
        {
            get
            {
                return this.icspmClient.getXMLData();
            }
        }
    }
}